<?php
/****************************************************************************
**
** Copyleft (C) 2015 Dominique Laporte <laporte.educnat@gmail.com>
** Copyleft (C) 2016 Yohan Lauer, Killian Camelin, Tho Mespoulet
**
** This file is part of smarteo
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 or version 3 as published by the Free
** Software Foundation and appearing in the file LICENSE.LGPLv21 and
** LICENSE.LGPLv3 included in the packaging of this file. Please review the
** following information to ensure the GNU Lesser General Public License
** requirements will be met: https://www.gnu.org/licenses/lgpl.html and
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
****************************************************************************/

/*
 *		module   : index.php
 *		projet   : traitement des appels aux diffrents modules
 *
 *		version  : 1.0
 *		auteur   : laporte
 *		creation : 17/03/02
 *		modif    : 
 */

// dbut de session
session_start();

// variables d'environnement
require "./globals.php";
require "./config.php";

$_SESSION["CFGDIR"]  = ( @$CFGDIR != "" )  ? $CFGDIR  : "." ;
$_SESSION["ROOTDIR"] = ( @$ROOTDIR != "" ) ? $ROOTDIR : "." ;
//---------------------------------------------------------------------------
require $_SESSION["ROOTDIR"]."/include/TMessage.php";
require $_SESSION["ROOTDIR"]."/include/hyla_tpl.class.php";
require $_SESSION["ROOTDIR"]."/include/sqltools.php";
require $_SESSION["ROOTDIR"]."/include/mylib.php";
//---------------------------------------------------------------------------
$time_start = getmicrotime();
$tpl = new Hyla_Tpl("tpl");
//---------------------------------------------------------------------------
// choix de la langue
if ( !empty($_GET["lang"]) )
	$_SESSION["lang"] = $_GET["lang"];
else
	if ( empty($_SESSION["lang"]) )
		if ( isset($_SERVER["HTTP_ACCEPT_LANGUAGE"]) ) {
			$list = explode(",", $_SERVER["HTTP_ACCEPT_LANGUAGE"]);
			$lang = strtolower(substr(chop($list[0]), 0, 2));

			$_SESSION["lang"] = ( $lang == "fr" OR $lang == "en" ) ? $lang : "fr" ;
			}
		else
			$_SESSION["lang"] = "fr";
//---------------------------------------------------------------------------
// connexion  la base de donnes
connectDatabase($SERVER, $USER, $PASSWD, $DATABASE, $SERVPORT);
//---------------------------------------------------------------------------
require "./banner.php";

//===== MVC =====
switch ( $item ) {
	case 1:	// temps rel
		require "./realtime.php";
		break;
		
	case 2:	// historique
		require "./log.php";
		break;

	case 21:	// graphique
		require "./graph.php";
		break;

	default:
		require "./home.php";
		break;
	}

require "./footer.php";

//---------------------------------------------------------------------------
// fermeture connexion base de donnes
$_SESSION["mysqli"]->close();
//---------------------------------------------------------------------------
?>
