<?php
/****************************************************************************
**
** Copyleft (C) 2015 Dominique Laporte <laporte.educnat@gmail.com>
**
** This file is part of smarteo
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 or version 3 as published by the Free
** Software Foundation and appearing in the file LICENSE.LGPLv21 and
** LICENSE.LGPLv3 included in the packaging of this file. Please review the
** following information to ensure the GNU Lesser General Public License
** requirements will be met: https://www.gnu.org/licenses/lgpl.html and
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
****************************************************************************/

/*
 *		module   : log.php
 *		projet   : affichage historique des mesures
 *
 *		version  : 1.0
 *		auteur   : laporte
 *		creation : 17/03/02
 *		modif    : 
 */


// Import du gabarit
$tpl->importFile("log.tpl");
//---------------------------------------------------------------------------
require "./msg/log.php";
$msg = new TMessage("./msg/".$_SESSION["lang"]."/log.php");
//---------------------------------------------------------------------------
function createCSV($filename, $date)
{
/*
 * fonction :	creation d'un fichier historique au format CSV
 * in :		$filename : nom du fichier CSV  gnrer, $date : critre de recherche (<d|w|m|y>:<valeur>)
 * out :	rien
 */

	$file = fopen("./tmp/$filename", "w");
	$list = explode(":", $date);

	// lecture des capteurs
	$query  = "select distinctrow capteurs_i10n._text, capteurs._unit ";
	$query .= "from capteurs_i10n, capteurs ";
	$query .= "where capteurs_i10n._lang = 'fr' ";
	$query .= "and capteurs_i10n._ID =  capteurs._ID ";
	$query .= "and capteurs._unit != '' ";
	$query .= "order by capteurs._ID asc";

	$result = $_SESSION["mysqli"]->query($query);
	$myrow  = ( $result ) ? remove_magic_quotes($result->fetch_row()) : 0;

	// cration fichier csv
	$fields = 1;
	$csv    = "date";

	while ( $myrow ) {
		$fields++;
		$csv .= ";$myrow[0] ($myrow[1])";

		$myrow = remove_magic_quotes($result->fetch_row());
		}

	// Libration du jeu de rsultats
	$result->close();

	// lecture des mesures
	$query  = "select distinctrow mesures._date, mesures._value ";
	$query .= "from mesures, capteurs ";
	$query .= "where capteurs._unit != '' ";
	$query .= "and mesures._ID =  capteurs._ID ";
	switch ( $list[0] ) {
		case 'd' :
			$query .= "and (mesures._date between '".date('Y')."-".date('m')."-$list[1] 0:0:0' and '".date('Y')."-".date('m')."-$list[1] 23:59:59') ";
			break;
		case 'w' :	//  faire
			break;
		case 'm' :
			$query .= "and (mesures._date between '".date('Y')."-$list[1]-1 0:0:0' and '".date('Y')."-$list[1]-31 23:59:59') ";
			break;
		default :
			$query .= "and (mesures._date between '$list[1]-1-1 0:0:0' and '$list[1]-12-31 23:59:59') ";
			break;
		}
	$query .= "order by mesures._date, actuateurs._ID asc";

	$result = $_SESSION["mysqli"]->query($query);
	$myrow  = ( $result ) ? remove_magic_quotes($result->fetch_row()) : 0;

	// cration fichier csv
	$count  = 0;

	while ( $myrow ) {
		if ( $count++ % $fields )
			$csv .= ";$myrow[1]";
		else {
			fputs($file, $csv);
			fputs($file, "\r\n");
			
			$csv  = "$myrow[0];$myrow[1]";
			$count++;
			}

		$myrow = remove_magic_quotes($result->fetch_row());
		}

	// Libration du jeu de rsultats
	$result->close();

	fputs($file, $csv);
	fputs($file, "\r\n");

	fclose($file);
}
//---------------------------------------------------------------------------

// donnes du formulaire
$day   = (int) @$_POST["day"];
$week  = (int) @$_POST["week"];
$month = (int) @$_POST["month"];
$year  = (int) @$_POST["year"];

// l'utilisateur a valid sa saisie
if ( @$_POST["submit"] == $msg->read($MSG_SEND) ) {
	if ( $day ) {
		$file = "d_$day.csv";
		createCSV($file, "d:$day");
		$tpl->setVar("day_csv","<a href=\"./tmp/$file\">$file</a>");
		$tpl->setVar("day_graph","<a href=\"?item=21&amp;file=d_$day\">".$msg->read($MSG_GRAPH)."</a>");
		}
	if ( $week ) {
		$file = "w_$week.csv";
		createCSV($file, "w:$week");
		$tpl->setVar("week_csv","<a href=\"./tmp/$file\">$file</a>");
		$tpl->setVar("week_graph","<a href=\"?item=21&amp;file=w_$week\">".$msg->read($MSG_GRAPH)."</a>");
		}		
	if ( $month ) {
		$file = "m_$month.csv";
		createCSV($file, "m:$month");
		$tpl->setVar("month_csv","<a href=\"./tmp/$file\">$file</a>");
		$tpl->setVar("month_graph","<a href=\"?item=21&amp;file=m_$month\">".$msg->read($MSG_GRAPH)."</a>");
		}
	if ( $year ) {
		$file = "y_$year.csv";
		createCSV($file, "y:$year");
		$tpl->setVar("year_csv","<a href=\"./tmp/$file\">$file</a>");
		$tpl->setVar("year_graph","<a href=\"?item=21&amp;file=y_$year\">".$msg->read($MSG_GRAPH)."</a>");
		}
	}

//---- jours du mois
$option = "<option value=\"0\">--</option>";
for ($i = 1; $i <= 31; $i++)
	$option .= "<option value=\"$i\">$i</option>";
$tpl->setVar('day_select', $option);

//---- semaine de l'anne
$option = "<option value=\"0\">--</option>";
for ($i = 1; $i <= 52; $i++)
	$option .= "<option value=\"$i\">$i</option>";
$tpl->setVar('week_select', $option);

//---- mois de l'anne
$option = "<option value=\"0\">--</option>";
for ($i = 1; $i <= 12; $i++)
	$option .= "<option value=\"$i\">$i</option>";
$tpl->setVar('month_select', $option);

//---- annes
$query  = "select min(_date), max(_date) ";
$query .= "from mesures ";
$query .= "limit 1";

$result =  $_SESSION["mysqli"]->query($query);
$myrow  = ( $result ) ? $result->fetch_row() : 0;

$option = "<option value=\"0\">--</option>";
while ( $myrow ) {
	$year    = explode("-", $myrow[0]);
	$option .= "<option value=\"$year[0]\">$year[0]</option>";

	$myrow = $result->fetch_row();
	}
	
// Libration du jeu de rsultats
$result->close();
	
$tpl->setVar('year_select', $option);

$tpl->setVar('day', $msg->read($MSG_DAY));
$tpl->setVar('week', $msg->read($MSG_WEEK));
$tpl->setVar('month', $msg->read($MSG_MONTH));
$tpl->setVar('year', $msg->read($MSG_YEAR));
$tpl->setVar('send', $msg->read($MSG_SEND));

// Affiche le rsultat
echo $tpl->render();
?>
