<?php
/****************************************************************************
**
** Copyleft (C) 2015 Dominique Laporte <laporte.educnat@gmail.com>
**
** This file is part of smarteo
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 or version 3 as published by the Free
** Software Foundation and appearing in the file LICENSE.LGPLv21 and
** LICENSE.LGPLv3 included in the packaging of this file. Please review the
** following information to ensure the GNU Lesser General Public License
** requirements will be met: https://www.gnu.org/licenses/lgpl.html and
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
****************************************************************************/

/*
 *		module   : index.php
 *		projet   : la page de configuration automatique smarteo
 *
 *		version  : 2.4
 *		auteur   : laporte
 *		creation : 29/06/03
 *		modif    : 
 */


// dbut de session
session_start();

// variables d'environnement pour l'hbergement de sites
require "./config.php";

$_SESSION["CFGDIR"]  = ( @$CFGDIR != "" )  ? $CFGDIR  : "." ;
$_SESSION["ROOTDIR"] = ( @$ROOTDIR != "" ) ? $ROOTDIR : "." ;

require "./setup.php";
//---------------------------------------------------------------------------
require "./msg/setup.php";
require $_SESSION["ROOTDIR"]."/include/TMessage.php";
require $_SESSION["ROOTDIR"]."/include/hyla_tpl.class.php";
require $_SESSION["ROOTDIR"]."/include/mylib.php";
//---------------------------------------------------------------------------
$time_start = getmicrotime();

// choix de la langue
if ( !empty($_GET["lang"]) )
	$_SESSION["lang"] = $_GET["lang"];
else
	if ( empty($_SESSION["lang"]) )
		if ( isset($_SERVER["HTTP_ACCEPT_LANGUAGE"]) ) {
			$list = explode(",", $_SERVER["HTTP_ACCEPT_LANGUAGE"]);
			$lang = strtolower(substr(chop($list[0]), 0, 2));

			$_SESSION["lang"] = ( $lang == "fr" OR $lang == "en" ) ? $lang : "fr" ;
			}
		else
			$_SESSION["lang"] = "fr";

//---------------------------------------------------------------------------
$step     = ( @$_POST["step"] )		// tape d'installation
	? (int) $_POST["step"]
	: 1 ;
$force    = (int) @$_POST["force"];		// forage de l'installation
$debug    = (int) @$_POST["debug"];		// mode debug
$charset  = ( @$_POST["charset"] )		// encodage
	? $_POST["charset"]
	: "iso-8859-1" ;
$dba      = @$_POST["dba"];			// base de donnes
$database = trim(@$_POST["database"]);
$server   = trim(@$_POST["server"]);
$user     = trim(@$_POST["user"]);
$passwd   = trim(@$_POST["passwd"]);
$servport = (int) @$_POST["servport"];
//---------------------------------------------------------------------------
$msg = new TMessage("./msg/".$_SESSION["lang"]."/setup.php");
$tpl = new Hyla_Tpl("tpl");
//---------------------------------------------------------------------------

// Import du gabarit
$tpl->importFile("step".$step.".tpl");

// entte
$tpl->setVar("title", $msg->read($MSG_APPLICATION) . " - ". $msg->read($MSG_TITLE));
$tpl->setVar("lang", $_SESSION["lang"]);
$tpl->setVar("charset", $charset);
$tpl->setVar("css", "./css/default/globals.css");
$tpl->setVar("favicon", $_SESSION["ROOTDIR"]."/images/favicon.png");

// formulaire
$tpl->setVar("debug", $debug);
$tpl->setVar("dba", $dba);

// texte
$tpl->setVar("appli", strtoupper($msg->read($MSG_APPLICATION)));
$tpl->setVar("info", $msg->read($MSG_PARAM));
$tpl->setVar("step", $step);
$tpl->setVar("langlist", $msg->languageBanner("msg"));

// initialisation
$help  = $msg->read($MSG_TIPS, $_SESSION["ROOTDIR"]."/docs/".$_SESSION["lang"]."_install.pdf");

switch ( $step ) {
	case 1 :	//==== vrification de la configuration ====
		$text   = $msg->read($MSG_STEP1, $VERSION);

		$php    = ( strcmp(phpversion(), "4.3") < 0 )
			? "wrn"
			: "on" ;
		$php    = "<img src=\"./images/check_$php.png\" title=\"\" alt=\"\" /> ". $msg->read($MSG_PHPVER, phpversion());
		$mysql  = ( function_exists('mysql_connect') )
			? "<img src=\"./images/check_on.png\" title=\"\" alt=\"O\" /> ". $msg->read($MSG_SQLON)
			: "<img src=\"./images/check_off.png\" title=\"\" alt=\"X\" /> ". $msg->read($MSG_SQLOFF) ;
		$config = ( is_writable($_SESSION["CFGDIR"]."/config.php") )
			? "<img src=\"./images/check_on.png\" title=\"\" alt=\"O\" /> ". $msg->read($MSG_CFGON)
			: "<img src=\"./images/check_off.png\" title=\"\" alt=\"X\" /> ". $msg->read($MSG_CFGOFF) ;
		$reg    = ( ini_get("register_globals") != "1" )
			? "<img src=\"./images/check_on.png\" title=\"\" alt=\"O\" /> ". $msg->read($MSG_REGOFF)
			: "<img src=\"./images/check_wrn.png\" title=\"\" alt=\"X\" /> ". $msg->read($MSG_REGON) ;

		// recherche de la version GD
		$version = "";
		$array   = get_loaded_extensions();
		foreach ($array as $key => $value)
			if ( $value == 'gd' ) {
				$ar      = gd_info();
				$version = $ar['GD Version'];
				break;
				}

		$gd     = ( $version )
			? "<img src=\"./images/check_on.png\" title=\"\" alt=\"O\" /> ". $msg->read($MSG_GDON, $version)
			: "<img src=\"./images/check_wrn.png\" title=\"\" alt=\"X\" /> ". $msg->read($MSG_GDOFF) ;

		$next  = ( function_exists('mysql_connect') AND is_writable($_SESSION["CFGDIR"]."/config.php") )
			? $msg->read($MSG_INSTALLOK). " <input type=\"submit\" value=\"". $msg->read($MSG_NEXT) ."\" />"
			: "<span style=\"color:#FF0000;\">". $msg->read($MSG_INSTALLFAIL). "</span>" ;

		$tpl->setVar("nextstep", $step + 1);
		$tpl->setVar("force", $force);

		$tpl->setVar("text", $text);
		$tpl->setVar("php", $php);
		$tpl->setVar("mysql", $mysql);
		$tpl->setVar("reg", $reg);
		$tpl->setVar("config", $config);
		$tpl->setVar("gd", $gd);
		$tpl->setVar("next", $next);

		break;

	case 2 :	//==== paramtrage de la connexion internet ====
		// valeurs par dfaut du serveur MySQL
		$server   = "localhost";
		$user     = "root";
		$passwd   = "";
		$database = $NAME;
		$servport = "";

		$tpl->setVar("nextstep", $step + 1);
		$tpl->setVar("force", $force);

		// saisie de la configuration
		$tpl->setVar("text", $msg->read($MSG_STEP2, $VERSION));
		$tpl->setVar("label_1", $msg->read($MSG_DBA));
		$tpl->setVar("label_2", $msg->read($MSG_SERVER));
		$tpl->setVar("label_3", $msg->read($MSG_USER));
		$tpl->setVar("label_4", $msg->read($MSG_PASSWD));
		$tpl->setVar("label_5", $msg->read($MSG_SERVPORT));
		$tpl->setVar("mandatory", $msg->read($MSG_MANDATORY));
		$tpl->setVar("next", $msg->read($MSG_CLICK). " <input type=\"submit\" value=\"". $msg->read($MSG_NEXT) ."\" />");

		break;

	case 3 :	//==== cration de la base de donnes ====
		// initialisation
		$prev = $next = $detect = $erase = "";

		// connexion  la base de donnes
		$servname = $server . ($servport ? ":$servport" : "");
		$_SESSION["mysqli"] = new mysqli($servname, $user, $passwd);
		
		if ( $_SESSION["mysqli"] ) {
			$text  = $msg->read($MSG_STEP3, Array($database, $dba));

			// recopie du fichier de configuration
			$config = $msg->read($MSG_CONFIG) . " ";

			$errcode = writeconfigfile("./config.ini", $_SESSION["CFGDIR"]."/config.php", $server, $user, $passwd, $database, $servport, $charset);
			switch ( $errcode ) {
				case -1 :
				case -2 :
					$config .= "<img src=\"./images/check_off.png\" title=\"\" alt=\"X\" /><br />";
					$config .= "<span style=\"color:#FF0000;\">";
					$config .= ( $errcode == -1 ) ? $msg->read($MSG_INIFAIL) : $msg->read($MSG_PHPFAIL) ;
					$config .= "</span>";
					break;

				default :
					$config .= "<img src=\"./images/check_on.png\" title=\"\" alt=\"O\" /><br />";
					break;
				}

			$create = $msg->read($MSG_CREATE, $database);

			// ouverture du rpertoire des fichiers sql
			$myDir = @opendir("./mysql");
			$files = "";

			// lecture des rpertoires
			while ( $entry = @readdir($myDir) )
				if ( strstr($entry, ".sql") )
					$files .= "<li>$entry</li>";

			// fermeture du rpertoire
			@closedir($myDir);

			// avertissement si une base de donnes a dj t installe
			$result = $_SESSION["mysqli"]->query("show tables from $database");
			$tables = ( $result ) ? $result->num_rows : 0 ;

			if( $tables ) {
				$detect = $msg->read($MSG_DETECT);
				$erase  = $msg->read($MSG_DONTERASE);
				}

			// vrification de la dernire installation
			$query  = "select _retcode from $database.config_database ";
			$query .= "order by _IDconf desc limit 1";

			$result = $_SESSION["mysqli"]->query($query);
			$row    = ( $result ) ? $result->fetch_row() : 0 ;

			// on force l'installation en cas d'erreur
			$force  = ( $row[0] ) ? 1 : $force ;

			$errtxt = ( $row[0] )
				? $msg->read($MSG_LASTERROR, $row[0])
				: "" ;

			$click  = ( $row[0] )
				? $msg->read($MSG_CONTINUE)
				: $msg->read($MSG_INSTALL) ;

		      $next = $click. " <input type=\"submit\" value=\"". $msg->read($MSG_NEXT) ."\" />";

			$tpl->setVar("nextstep", $step + 1);
			$tpl->setVar("force", $force);

			$tpl->setVar("config", $config);
			$tpl->setVar("create", $create);
			$tpl->setVar("files", $files);
			$tpl->setVar("detect", $detect);
			$tpl->setVar("erase", $erase);
			$tpl->setVar("errtxt", $errtxt);
			$tpl->setVar("next", $next);

			if ( $files ) $tpl->render("files");
			if ( $tables ) $tpl->render("detect");
			if ( $errtxt ) $tpl->render("errtxt");
			
			$_SESSION["mysqli"]->close();
			}
		else {
			$text  = "<img src=\"./images/check_off.png\" title=\"\" alt=\"X\" /> ". $msg->read($MSG_CONNECTFAIL); 
			$prev  = "<input type=\"submit\" value=\"". $msg->read($MSG_PREV) ."\" />";

			$tpl->setVar("nextstep", $step - 1);

			$tpl->setVar("errno", $_SESSION["mysqli"]->errno);
			$tpl->setVar("error", $_SESSION["mysqli"]->error);
			$tpl->setVar("prev", $prev);

			$tpl->render("errno");
			$tpl->render("prev");
			}

		$tpl->setVar("text", $text);
		break;

	case 4 :	//==== paramtrage de l'intranet ====
		// initialisation
		$text     = $msg->read($MSG_STEP4, $msg->read($MSG_APPLICATION));
		$warning  = $msg->read($MSG_DELETE);
		$errtxt   = $sqlerror = "";

		// les langues disponibles
		$langlist = Array();

		// ouverture du rpertoire des langues
		$myDir    = @opendir("./msg");

		// lecture des rpertoires
		while ( $entry = @readdir($myDir) )
			if ( is_dir("./msg/$entry") AND strlen($entry) == 2 )
				switch ( $entry ) {
					case "." :
					case ".." :
						break;

					default :
						array_push($langlist, $entry);
						break;
					}

		// fermeture du rpertoire
		@closedir($myDir);

				// connexion  la base de donnes
		$servname = $server . ($servport ? ":$servport" : "");
		$_SESSION["mysqli"] = new mysqli($servname, $user, $passwd);
		
		$error = ( @$_POST["cb"] == "ON" )
			// mise  jour de la base de donnes
			? updatedatabase($database, $langlist, $sqlerror)
			// cration de la base de donnes
			: createdatabase($database, $langlist, $dba, $sqlerror) ;
			
		$_SESSION["mysqli"]->close();

		$config = $msg->read($MSG_DBATITLE, $database). " ";

		switch ( $error ) {
			case -2 :
				$config .= "<img src=\"./images/check_off.png\" title=\"\" alt=\"X\" />";

				$errtxt  = $msg-read($MSG_FAILED, "./mysql/$dba/$database");
				break;
			case -1 :
				$config .= "<img src=\"./images/check_off.png\" title=\"\" alt=\"X\" />";

				$errtxt  = $msg->read($MSG_CONNECTERROR, $database);
				break;
			case 0 :
				$config .= "<img src=\"./images/check_on.png\" title=\"\" alt=\"O\" /><br/>";
				$config .= $msg->read($MSG_DBAOK);
				$config .= $sqlerror;	// liste des patch appliqus en mise  jour
				break;
			default :
				$config .= "<img src=\"./images/check_off.png\" title=\"\" alt=\"X\" />";

				$errtxt  = $msg->read($MSG_DBAFAIL);
				break;
			}

		if ( $error ) {
			$action = "./index.php";
			$prev   = "<input type=\"submit\" value=\"". $msg->read($MSG_PREV) ."\" />";
			$next   = ( @$_POST["cb"] == "ON" )
				? $msg->read($MSG_CONTINUE)." <input type=\"submit\" value=\"". $msg->read($MSG_NEXT) ."\" />"
				: "" ;

			$tpl->setVar("nextstep", $step - 1);
			$tpl->setVar("errtxt", $errtxt);
			$tpl->setVar("sqlerror", $sqlerror);
			$tpl->setVar("prev", $prev);

			$tpl->render("errtxt");
			$tpl->render("sqlerror");
			$tpl->render("prev");
			}
		else {
			// on lance l'application
			$action = $_SESSION["ROOTDIR"]."/index.php";
			$next   = $msg->read($MSG_CONNECTNOW)." <input type=\"submit\" value=\"". $msg->read($MSG_NEXT) ."\" />";

			$tpl->setVar("warning", $warning);

			$tpl->render("warning");
			}

		$tpl->setVar("action", $action);
		$tpl->setVar("text", $text);
		$tpl->setVar("config", $config);
		$tpl->setVar("next", $next);

		if ( $next )
			$tpl->render("next");
		break;

	default:
		break;
	}

// le formulaire
$tpl->setVar("database", $database);
$tpl->setVar("server", $server);
$tpl->setVar("user", $user);
$tpl->setVar("passwd", $passwd);
$tpl->setVar("servport", $servport);

$tpl->setVar("help", $help);

// le temps de gnration des pages
$time  = (int) ((getmicrotime() - $time_start) * 1000);
$time /= 1000;

$generate =	$msg->read($MSG_GENERATION, "$time");

$tpl->setVar("generate", $generate);

// Affiche le rsultat
echo $tpl->render();
?>
