<!-- Chargement des variables, et paramètres de Highcharts -->
<script type="text/javascript">
	$(function () {
        $('#container').highcharts({
            chart: {
                type: 'areaspline'
            },
            title: {
                text: '{$title}'
            },
            legend: {
                layout: 'vertical',
                align: 'left',
                verticalAlign: 'top',
                x: 150,
                y: 100,
                floating: true,
                borderWidth: 1,
                backgroundColor: (Highcharts.theme && Highcharts.theme.legendBackgroundColor) || '#FFFFFF'
            },
            xAxis: {
                categories : [{$categorie}],
                plotBands: [{ 
                    from: 4.5,
                    to: 6.5,
                    color: 'rgba(68, 170, 213, .2)'
                }]
            },
            yAxis: {
                title: {
                    text: '{$value}'
                }
            },
            tooltip: {
                shared: true,
                valueSuffix: '{$unit}'
            },
            credits: {
                enabled: false
            },
            plotOptions: {
                areaspline: {
                    fillOpacity: 0.5
                }
            },
            series: [{
                {$series}
            }]
        });
    });
            
</script>

<div id="container" style="min-width: 310px; height: 400px; margin: 0 auto"></div>        